Leetcode237: Palindrome Partitioning II

243 篇文章 0 订阅

Given a string s, partition s such that every substring of the partition is a palindrome.

Return the minimum cuts needed for a palindrome partitioning of s.

For example, given s = "aab",

Return 1 since the palindrome partitioning ["aa","b"] could be produced using 1 cut.

 如果用Palindrome Partitioning中的DFS和回溯法,那么会超时。

class Solution {
private:
    int cut = INT_MAX;
public:
    void dfs(string s, vector<string> &path)  
    {  
        if(s.size() < 1)  
        {  
            if(path.size()-1 < cut)
                cut = path.size()-1;
            return;  
        }  
        for(int i = 0; i < s.size(); i++)  
        {  
            int begin = 0;  
            int end = i;  
            while(begin < end)  
            {  
                if(s[begin] == s[end])  
                {  
                    begin++;  
                    end--;  
                }  
                else  
                    break;  
            }  
            if(begin >= end)//bool isPalindrome = true;  
            {  
                path.push_back(s.substr(0,i+1));  
                dfs(s.substr(i+1),path);  
                path.pop_back();  
            }  
        }  
    }  
    void partition(string s) {  
        vector<string> path;  
        dfs(s,path);  
    } 
    int minCut(string s) {
        partition(s);
        return cut;
    }
};
复杂的问题可以转用动态规划:

定义函数
D[i,n] = 区间[i,n]之间最小的cut数,n为字符串长度
 a   b   a   b   b   b   a   b   b   a   b   a
                     i                                  n
如果现在求[i,n]之间的最优解?应该是多少?简单看一看,至少有下面一个解
 a   b   a   b   b   b   a   b   b   a   b   a
                    i                    j+1      n
此时  D[i,n] = min(D[i, j] + D[j+1,n])  i<=j <n。这是个二维的函数,实际写代码时维护比较麻烦。所以要转换成一维DP。如果每次,从i往右扫描,每找到一个回文就算一次DP的话,就可以转换为
D[i] = 区间[i,n]之间最小的cut数,n为字符串长度, 则,
D[i] = min(1+D[j+1] )    i<=j <n
有个转移函数之后,一个问题出现了,就是如何判断[i,j]是否是回文?每次都从i到j比较一遍?太浪费了,这里也是一个DP问题。
定义函数
P[i][j] = true if [i,j]为回文
那么
P[i][j] = ((str[i] == str[j]) && (P[i+1][j-1]));

class Solution {
public:
    int minCut(string s) {  
        int len = s.size();  
        int D[len+1];  
        bool P[len][len];  
        //the worst case is cutting by each char  
        for(int i = 0; i <= len; i++)   
        D[i] = len-i;  
        for(int i = 0; i < len; i++)  
        for(int j = 0; j < len; j++)  
        P[i][j] = false;  
        for(int i = len-1; i >= 0; i--){  
             for(int j = i; j < len; j++){  
                  if(s[i] == s[j] && (j-i<2 || P[i+1][j-1])){  
                       P[i][j] = true;  
                       D[i] = min(D[i],D[j+1]+1);  
                  }  
             }  
        }  
        return D[0]-1;  
    }
};


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值